=== debian/control ===
Source: td-build-tools-template
Section: utils
Priority: optional
Maintainer: Thomas Dreibholz <thomas.dreibholz@gmail.com>
Homepage: https://www.nntb.no/~dreibh/build-tools-template/
Build-Depends: cmake,
               debhelper-compat (= 13),
               gettext
Standards-Version: 4.7.2
Rules-Requires-Root: no

Package: libexamplelibrary0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${misc:Depends},
         ${shlibs:Depends}
Description: Example library
 This is a simple example library to be build and packaged by
 Build Tool.
 .
 The example library is provided by this package.

Package: libexamplelibrary-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends: libexamplelibrary0 (= ${binary:Version}),
         ${misc:Depends}
Description: Development files for example library
 This is a simple example library to be build and packaged by
 Build Tool.
 .
 This package provides header files for the library.

Package: td-build-tools-example-programs
Architecture: any
Depends: libexamplelibrary0 (= ${binary:Version}),
         ${misc:Depends},
         ${shlibs:Depends}
Description: Build tools example programs
 These are simple example programs and files to be build and packaged by
 Build Tool.

Package: td-build-tools-example-scripts
Architecture: all
Depends: gettext-base,
         python3,
         ${misc:Depends}
Description: Build tools example scripts
 These are simple example scripts and files to be build and packaged by
 Build Tool.

Package: td-build-tools-template
Architecture: all
Depends: ${misc:Depends}
Description: Build tools template metapackage
 This is a metapackage to install the simple example programs,
 scripts, and files packaged by Build Tool.
